'**************************************
'
' C-Control/BASIC        COUNTLCD.BAS
'
' Aufgabe:
'
' - Zhler mit LCD-Ausgabe
' - 4-Bit Ansteuerung 
' - Eingang 8
'
'**************************************
' --- Definitionen --------------------

define lcd_port byteport[2]
define lcd_rs port[14]
define lcd_rw port[13]
define lcd_e port[15]
define lcd_buf byte
define lcd_param byte

define Eingang port[8]
define Zaehler word
define Zahl word
define Ziffer Byte


' --- Programmoperationen -------------

  gosub LCD_INIT
  pause 10
  Zaehler = 0
#Loop
  wait Eingang
  pause 2
  wait not (Eingang)
  Zaehler = Zaehler + 1
  gosub Ausgabe
goto Loop  

#Ausgabe
  Zahl = Zaehler      
  lcd_param = 1
  gosub LCD_GOTOLINE
  lcd_param = 90      '"Z"
  gosub LCD_WRITECHAR
  lcd_param = 32      '" "
  gosub LCD_WRITECHAR
  Ziffer = Zahl / 10000
  lcd_param = Ziffer + 48
  gosub LCD_WRITECHAR
  Zahl = Zahl - 10000*Ziffer
  Ziffer = Zahl / 1000
  lcd_param = Ziffer + 48
  gosub LCD_WRITECHAR
  Zahl = Zahl - 1000*Ziffer
  Ziffer = Zahl / 100
  lcd_param = Ziffer + 48
  gosub LCD_WRITECHAR
  Zahl = Zahl - 100*Ziffer
  Ziffer = Zahl / 10
  lcd_param = Ziffer + 48
  gosub LCD_WRITECHAR
  Zahl = Zahl - 10*Ziffer
  Ziffer = Zahl 
  lcd_param = Ziffer + 48
  gosub LCD_WRITECHAR
return  

'*** LCD_Interface ***

#LCD_INIT

' alle ports 0
  lcd_port = OFF

' 8-Bit-Modus aktivieren
  lcd_param=&H38 : gosub LCD_WRITECMD

' mit 8-Bit-Command in 4-Bit-Modus umschalten
  lcd_port=&B00000010
  tog lcd_e
  tog lcd_e

' ab jetzt 4-Bit-Modus
  lcd_param = &H28 : gosub LCD_WRITECMD
  lcd_param = &H0C : gosub LCD_WRITECMD

' Display loeschen
#LCD_CLS
  lcd_param = &H02 : gosub LCD_WRITECMD
  lcd_param = &H01 : gosub LCD_WRITECMD
return

' Zeilenwechsel
#LCD_GOTOLINE
  if lcd_param = 1 then lcd_param = &H80
  if lcd_param = 2 then lcd_param = &HC0
  goto LCD_WRITECMD

' LCD-Kommando
#LCD_WRITECMD
  lcd_buf = OFF
  goto LCD_WRITE

' Zeichenausgabe
#LCD_WRITECHAR
  lcd_buf = &B00100000

' Kommando oder Zeichen an Display senden
#LCD_WRITE
' Hi-Nibble
  lcd_port = lcd_buf or (lcd_param shr 4) 
  tog lcd_e
  tog lcd_e
' Lo-Nibble
  lcd_port = lcd_buf or (lcd_param and &H0F)  
  tog lcd_e
  tog lcd_e
return

