'**************************************
'
' C-Control/BASIC       ROBOT3.BAS
'
' Aufgabe:
'
' - Robotersteuerung mit 2 Motoren
' - Ansteuerung ber PWM-Ausgaenge
' - Kurssteuerung ueber Lichtstrahl
'
'**************************************
' --- Definitionen --------------------

define MotorL DA[1]
define MotorR DA[2]
define LDR1 AD[1]
define LDR2 AD [2]
define PowerON Port[1]

' --- Programmoperationen -------------

#Loop
  PowerON = 0
  if (LDR1<20) and (LDR2<20) then goto Loop
#GO
  if LDR1>LDR2 then gosub Links
  if LDR2>LDR1 then gosub Rechts
  if (LDR1<20) and (LDR2<20) then goto Loop
  if (LDR1+LDR2)>400 then PowerON=0: Pause 10
  goto GO

#Links
  MotorR = 255
  MotorL = 255 - (LDR1-LDR2)
  PowerON = 1
  return

#Rechts
  MotorL = 255
  MotorR = 255 - (LDR2-LDR1)
  PowerON = 1
  return


