'---------------------------------------------------------------------------
'Zentrum fuer Fuzzy- & InformationsTechnik GmbH
'Baumhofweg 4
'D-44267 Dortmund
'
'Copyright (C) by ZeTec
'All rights reserved.

'Dieser Basic-Code wurde automatisch mit der FCU generiert und beinhaltet
'den gesamten Algorithmus zur Berechnung des Fuzzy-Reglers.
'---------------------------------------------------------------------------


DEFINE Summe_Efg    WORD
DEFINE Rest_Summe   WORD
DEFINE Rest_Dummy   WORD
DEFINE Aus_Wert     BYTE
DEFINE Akt_Efg      BYTE
DEFINE Reg_Anzahl   BYTE
DEFINE Akt_Regel    BYTE
DEFINE Set_Param    BYTE
DEFINE A            BYTE
DEFINE B            BYTE
DEFINE C            BYTE
DEFINE D            BYTE
DEFINE Eingang      BYTE

DEFINE Eingang_1        AD[1]
DEFINE Ausgang_1        DA[1]
Define Ausgang_2    Wordport[1]
Define DigitalAus  word

#ANFANG

  LOOKTAB Fuzzy_Sets, 0, Reg_Anzahl
  Reg_Anzahl = Reg_Anzahl-1

  Summe_Efg =  0
  Aus_Wert =   0
  Rest_Summe = 0
  Rest_Dummy = 0

  Eingang = Eingang_1

  FOR Akt_Regel = 0 TO Reg_Anzahl

    Akt_Efg = 0

    Set_Param = 5 * Akt_Regel + 1
    LOOKTAB Fuzzy_Sets, Set_Param, A
    IF A > Eingang THEN GOTO FOR_ENDE_1

    Set_Param = Set_Param + 3
    LOOKTAB Fuzzy_Sets, Set_Param, D
    IF D < Eingang THEN GOTO FOR_ENDE_1

    Set_Param = Set_Param - 2
    LOOKTAB Fuzzy_Sets, Set_Param, B

    Set_Param = Set_Param + 1
    LOOKTAB Fuzzy_Sets, Set_Param, C

    Akt_Efg = 100

    IF Eingang < B THEN Akt_Efg = (Eingang - A) * 100 / (B- A)

    IF Eingang > C THEN Akt_Efg = 100 - (Eingang - C) * 100 / (D - C)

    Summe_Efg = Summe_Efg + Akt_Efg

    #FOR_ENDE_1
  NEXT

  IF Summe_Efg = 0 THEN GOTO ANFANG

  FOR Akt_Regel = 0 TO Reg_Anzahl

    Akt_Efg = 0

    Set_Param = 5 * Akt_Regel + 1
    LOOKTAB Fuzzy_Sets, Set_Param, A
    IF A > Eingang THEN GOTO FOR_ENDE_2

    Set_Param = Set_Param + 3
    LOOKTAB Fuzzy_Sets, Set_Param, D
    IF D < Eingang THEN GOTO FOR_ENDE_2

    Set_Param = Set_Param - 2
    LOOKTAB Fuzzy_Sets, Set_Param, B

    Set_Param = Set_Param + 1
    LOOKTAB Fuzzy_Sets, Set_Param, C

    Akt_Efg = 100

    IF Eingang < B THEN  Akt_Efg = (Eingang - A) * 100 / (B- A)

    IF Eingang > C THEN Akt_Efg = 100 - (Eingang - C) * 100 / (D - C)

    Set_Param = 5 * Akt_Regel + 5
    LOOKTAB Fuzzy_Sets, Set_Param, A

    Aus_Wert=Aus_Wert+(A*Akt_Efg)/Summe_Efg

    Rest_Dummy = Rest_Dummy + (A * Akt_Efg) MOD Summe_Efg

    IF Rest_Dummy < 0 THEN GOSUB ZWISCHEN_REST ELSE Rest_Summe = Rest_Dummy

   #FOR_ENDE_2
  NEXT

  Aus_Wert = Aus_Wert + Rest_Summe / Summe_Efg

  Ausgang_1 = Aus_Wert
  DigitalAus = 0                                        '
  if Aus_Wert >   8 then DigitalAus = &B0000000000000001
  if Aus_Wert >  24 then DigitalAus = &B0000000000000011
  if Aus_Wert >  40 then DigitalAus = &B0000000000000111
  if Aus_Wert >  56 then DigitalAus = &B0000000000001111
  if Aus_Wert >  72 then DigitalAus = &B0000000000011111
  if Aus_Wert >  88 then DigitalAus = &B0000000000111111
  if Aus_Wert > 104 then DigitalAus = &B0000000001111111
  if Aus_Wert > 120 then DigitalAus = &B0000000011111111
  if Aus_Wert > 136 then DigitalAus = &B0000000111111111
  if Aus_Wert > 152 then DigitalAus = &B0000001111111111
  if Aus_Wert > 168 then DigitalAus = &B0000011111111111
  if Aus_Wert > 184 then DigitalAus = &B0000111111111111
  if Aus_Wert > 200 then DigitalAus = &B0001111111111111
  if Aus_Wert > 216 then DigitalAus = &B0011111111111111
  if Aus_Wert > 232 then DigitalAus = &B0111111111111111
  if Aus_Wert > 248 then DigitalAus = &B1111111111111111
  Ausgang_2 = DigitalAus

GOTO ANFANG

END


#ZWISCHEN_REST
  Rest_Summe = Rest_Summe / Summe_Efg
  Aus_Wert = Aus_Wert + Rest_Summe
  Rest_Dummy = (A * Akt_Efg) MOD Summe_Efg
  Rest_Summe = Rest_Summe MOD Summe_Efg
  Rest_Summe = Rest_Summe + Rest_Dummy
RETURN
TABLE Fuzzy_Sets
8
0   0   0   20  0
0   20  20  40  52
20  40  40  70  90
40  70  70  110 120
70  110 110 160 150
110 160 160 220 180
160 220 220 255 210
220 255 255 255 220
