'*******************************************
'
'  C-Control/BASIC       LEDANZ.BAS
'  LED-Anzeige fr Spannung und Frequenz
'  Ausgabeformat: 4.9 999 
'
'******************************************

' --- Definitionen ------------------------

define Frequenz  word
define Spannung byte
define Eingang1 AD[1]

' *** Ports zur Ansteuerung des LED-Moduls ***

' Starter Board
define led_clk port[10]
define led_en port[11]
define led_data port[14]

' alternativ Application Board
'define led_clk port[14]
'define led_en port[15]
'define led_data port[10]

' Systemadressen
define LEDVAL &H101      ' Ausgabe eines Wertes
define LEDDIGIT &H187    ' Ausgabe eines Zeichens

' Zeichencodes

define LED_SPACE 255


' --- Programmopeartionen ------------

' *** Initialisierungen ***
led_clk=0
led_en=0
led_data=0

' *** Ausgabe ***
#Loop
led_en = ON          'schaltet alle Segmente aus
  Frequenz = FREQ           '0...999 Hz
  sys LEDVAL Frequenz,0,3   '999
  sys LEDDIGIT LED_Space    'Leerzeichen
  Spannung = Eingang1 / 5   '0...51, 0-5.1V
  sys LEDVAL Spannung,2,2   '4.9 999 
  led_en = OFF       'schaltet die Segmente ein
  pause 10
goto Loop

end

syscode "ledstbrd.s19"  ' Starter Board
'syscode "ledapbrd.s19" ' Application Board
